Public Class MoneyWithError
    Private mdValue As Decimal
    Private msError As String = String.Empty

    Public Sub New(ByVal sError As String)
        msError = sError
    End Sub

    Public Sub New(ByVal dValue As Decimal)
        mdValue = dValue
    End Sub

    Public ReadOnly Property Message() As String
        Get
            Return msError
        End Get
    End Property

    Public ReadOnly Property MoneyValue() As Decimal
        Get
            Return mdValue
        End Get
    End Property

    Public ReadOnly Property IsError() As Boolean
        Get
            Return msError <> String.Empty
        End Get
    End Property
End Class
